;**************************************************************************************************
;
;						LCD.ASM				13-10-07
;
;
;
;**************************************************************************************************

;**************************************************************************************************

;	PROCESSOR mega 8  16
;	Clock = 16 MHz

;**************************************************************************************************



;**************************************************************************************************

	.include "m32def.inc"
;	.include "m8def.inc"


	.def BUF		= r16	;   1ms
	.def ADR		= r17	;    
	.def LCD_PAGE		= r18	;  
	.def Temp		= r21
	.def Timer1		= r22	;
	.def TimerX		= r23	;



;******************************************************************************
;          DEFINE  OUTPUT PORORT
;******************************************************************************
;RS              REG     P3.0
;E               REG     P3.4
;RES             REG     P3.2
;CS1             REG     P3.3
;CS2             REG     P3.5
;R_W             REG     P3.7

;STP             REG     P2.0
;S_S             REG     P2.1

;BCD             EQU     01H

;---------------------------
;				PORTD

	.EQU RS		= 2
	.EQU E		= 4
	.EQU RES	= 7
	.EQU CS1	= 5
	.EQU CS2	= 6
	.EQU R_W	= 3
;---------------------------



;   ******************************************************************************

	.CSEG
	.ORG $0000			;  

		rjmp 	RESET	;reset entry vector
		
		
RESET:

		ldi			temp,0x80
		out			ACSR,temp

		ldi			temp, LOW(RAMEND) ;setup stack pointer
		out 		SPL, temp
		ldi			temp, HIGH(RAMEND)
		out			SPH, temp


;		rjmp		DDD

;		rjmp		WORLD
;------------------------------------------------
		;   A
		; 


		ldi			Temp,(1<<7)|(1<<6)|(1<<5)|(1<<4)|(1<<3)|(1<<2)|(1<<1)|(1<<0)
					; 1 =  , 0 = 

		out			DDRA,Temp

		ldi			Temp,0xFF
		out			PORTA,Temp

;------------------------------------------------
		;   B

		ldi			Temp,(1<<7)|(1<<6)|(1<<5)|(1<<4)|(1<<3)|(1<<2)|(1<<1)|(1<<0)
					; 1 =  , 0 = 

		out			DDRB,Temp

		ldi			Temp,0xFF
		out			PORTB,Temp

;------------------------------------------------
		;   C - 

		ldi			Temp,(1<<7)|(1<<6)|(1<<5)|(1<<4)|(1<<3)|(1<<2)|(1<<1)|(1<<0)
					; 1 =  , 0 = 

		out			DDRC,Temp

		ldi			Temp,0x00
		out			PORTC,Temp

;------------------------------------------------
		;   D - 
	
		ldi			Temp,(1<<7)|(1<<6)|(1<<5)|(1<<4)|(1<<3)|(1<<2)|(1<<1)|(1<<0)
					; 1 =  , 0 = 

		out			DDRD,Temp

		ldi			Temp,0xFF
		out			PORTD,Temp


;**************************************************************************************************



;		rjmp	FULL_ON	

;	 16  1  = 0.000 000 062 5


;******************************************************************************
                
START:	;program reset start here

;  (Reset) LCD

		ldi			TimerX,0x08
		cbi			PORTD,RES			;  
		rcall		X_ms
		sbi			PORTD,RES			; 7

		
		ldi			TimerX,0x08
		rcall		X_ms	

		;INITIAL
		;----------------------------------------------------------------------
		;Set Y Column Address >From 0 -    =0

		ldi			BUF,(0<<7)|(1<<6)|(0<<5)|(0<<4)|(0<<3)|(0<<2)|(0<<1)|(0<<0) ; 0x40

		rcall		WRITE_COMMAND1

		rcall		WRITE_COMMAND2

		rcall		One_ms
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms

		;----------------------------------------------------------------------
		;Set Page From 0 -    =0

		ldi			BUF,(1<<7)|(0<<6)|(1<<5)|(1<<4)|(1<<3)|(0<<2)|(0<<1)|(0<<0) ; 0xB8

		rcall		WRITE_COMMAND1

		rcall		WRITE_COMMAND2

		rcall		One_ms
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms

		;----------------------------------------------------------------------
		;Set Display Start Line -       

		ldi 		BUF,(1<<7)|(1<<6)|(0<<5)|(0<<4)|(0<<3)|(0<<2)|(0<<1)|(0<<0) ; C0

		rcall		WRITE_COMMAND1

		rcall		WRITE_COMMAND2

		rcall		One_ms
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms

		;----------------------------------------------------------------------
		;Set Display ON -  

		ldi			BUF,(0<<7)|(0<<6)|(1<<5)|(1<<4)|(1<<3)|(1<<2)|(1<<1)|(1<<0) ; 0x3F

		rcall		WRITE_COMMAND1

		rcall		WRITE_COMMAND2

		rcall		One_ms
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms

		rjmp		WORLD

;******************************************************************************
WRITE_COMMAND1:                                 ;Write Command To CS1
		cbi			PORTD,CS2
		nop
		nop
		nop
		nop
		sbi			PORTD,CS1
		cbi			PORTD,RS
		cbi			PORTD,R_W
		out			PORTC,BUF
		rcall		One_ms
		sbi			PORTD,E
		rcall		One_ms
		cbi			PORTD,E
		ret

;******************************************************************************
WRITE_DATA1:                                    ;Write Data To CS1
		cbi			PORTD,CS2
		nop
		nop
		nop
		nop
		sbi			PORTD,CS1
		sbi			PORTD,RS
		cbi			PORTD,R_W
		out			PORTC,BUF
		rcall		One_ms
		sbi			PORTD,E
		rcall		One_ms
		cbi			PORTD,E
		ret

;******************************************************************************
WRITE_COMMAND2:                                 ;Write Command To CS2
		nop
		cbi			PORTD,CS1
		nop
		nop
		nop
		nop
		sbi			PORTD,CS2
		cbi			PORTD,RS
		cbi			PORTD,R_W
		out			PORTC,BUF
		rcall		One_ms
		sbi			PORTD,E
		rcall		One_ms
		cbi			PORTD,E
		ret

;******************************************************************************
WRITE_DATA2:                                    ;Write Data To CS2
		cbi			PORTD,CS1
		nop
		nop
		nop
		nop
		sbi			PORTD,CS2
		sbi			PORTD,RS
		cbi			PORTD,R_W
		out			PORTC,BUF
		rcall		One_ms
		sbi			PORTD,E
		rcall		One_ms
		cbi			PORTD,E
		ret


;******************************************************************************
;*              DISPLAY DATA
;******************************************************************************
WORLD:

		ldi			ZL,low(TABLE*2)
		ldi			ZH,high(TABLE*2)

		;--------------------------------------------------------------------------------
		ldi			BUF,(1<<7)|(0<<6)|(1<<5)|(1<<4)|(1<<3)|(0<<2)|(0<<1)|(0<<0) ; 0xB8	;    =0

		rcall		WRITE_COMMAND1	; ADR

		rcall		One_ms
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms

		ldi			BUF,(0<<7)|(1<<6)|(0<<5)|(0<<4)|(0<<3)|(0<<2)|(0<<1)|(0<<0) ; 0x40	;    =0

		rcall		WRITE_COMMAND1	; LCD_PAGE	

		ldi			ADR,0x40
		clr			Temp
LOOP_C1_0:								;    1 
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms
		lpm			BUF,Z+
		rcall		WRITE_DATA1
		inc			Temp
		cpse		Temp,ADR			;  =    

		rjmp		LOOP_C1_0

		;--------------------------------------------------------------------------------
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms

		ldi			BUF,(1<<7)|(0<<6)|(1<<5)|(1<<4)|(1<<3)|(0<<2)|(0<<1)|(1<<0) ; 0xB8	;    =0

		rcall		WRITE_COMMAND1	; ADR

		rcall		One_ms
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms

		ldi			BUF,(0<<7)|(1<<6)|(0<<5)|(0<<4)|(0<<3)|(0<<2)|(0<<1)|(0<<0) ; 0x40	;    =0

		rcall		WRITE_COMMAND1	; LCD_PAGE	

		ldi			ADR,0x40
		clr			Temp
LOOP_C1_1:								;    1 
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms
		lpm			BUF,Z+
		rcall		WRITE_DATA1
		inc			Temp
		cpse		Temp,ADR			;  =    

		rjmp		LOOP_C1_1

		;--------------------------------------------------------------------------------
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms

		ldi			BUF,(1<<7)|(0<<6)|(1<<5)|(1<<4)|(1<<3)|(0<<2)|(1<<1)|(0<<0) ; 0xB8	;    =0

		rcall		WRITE_COMMAND1	; ADR

		rcall		One_ms
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms

		ldi			BUF,(0<<7)|(1<<6)|(0<<5)|(0<<4)|(0<<3)|(0<<2)|(0<<1)|(0<<0) ; 0x40	;    =0

		rcall		WRITE_COMMAND1	; LCD_PAGE	

		ldi			ADR,0x40
		clr			Temp
LOOP_C1_2:								;    1 
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms
		lpm			BUF,Z+
		rcall		WRITE_DATA1
		inc			Temp
		cpse		Temp,ADR			;  =    

		rjmp		LOOP_C1_2

		;--------------------------------------------------------------------------------
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms

		ldi			BUF,(1<<7)|(0<<6)|(1<<5)|(1<<4)|(1<<3)|(0<<2)|(1<<1)|(1<<0) ; 0xB8	;    =0

		rcall		WRITE_COMMAND1	; ADR

		rcall		One_ms
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms

		ldi			BUF,(0<<7)|(1<<6)|(0<<5)|(0<<4)|(0<<3)|(0<<2)|(0<<1)|(0<<0) ; 0x40	;    =0

		rcall		WRITE_COMMAND1	; LCD_PAGE	

		ldi			ADR,0x40
		clr			Temp
LOOP_C1_3:								;    1 
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms
		lpm			BUF,Z+
		rcall		WRITE_DATA1
		inc			Temp
		cpse		Temp,ADR			;  =    

		rjmp		LOOP_C1_3

		;--------------------------------------------------------------------------------
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms

		ldi			BUF,(1<<7)|(0<<6)|(1<<5)|(1<<4)|(1<<3)|(1<<2)|(0<<1)|(0<<0) ; 0xB8	;    =0

		rcall		WRITE_COMMAND1	; ADR

		rcall		One_ms
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms

		ldi			BUF,(0<<7)|(1<<6)|(0<<5)|(0<<4)|(0<<3)|(0<<2)|(0<<1)|(0<<0) ; 0x40	;    =0

		rcall		WRITE_COMMAND1	; LCD_PAGE	

		ldi			ADR,0x40
		clr			Temp
LOOP_C1_4:								;    1 
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms
		lpm			BUF,Z+
		rcall		WRITE_DATA1
		inc			Temp
		cpse		Temp,ADR			;  =    

		rjmp		LOOP_C1_4

		;--------------------------------------------------------------------------------
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms

		ldi			BUF,(1<<7)|(0<<6)|(1<<5)|(1<<4)|(1<<3)|(1<<2)|(0<<1)|(1<<0) ; 0xB8	;    =0

		rcall		WRITE_COMMAND1	; ADR

		rcall		One_ms
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms

		ldi			BUF,(0<<7)|(1<<6)|(0<<5)|(0<<4)|(0<<3)|(0<<2)|(0<<1)|(0<<0) ; 0x40	;    =0

		rcall		WRITE_COMMAND1	; LCD_PAGE	

		ldi			ADR,0x40
		clr			Temp
LOOP_C1_5:								;    1 
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms
		lpm			BUF,Z+
		rcall		WRITE_DATA1
		inc			Temp
		cpse		Temp,ADR			;  =    

		rjmp		LOOP_C1_5

		;--------------------------------------------------------------------------------
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms

		ldi			BUF,(1<<7)|(0<<6)|(1<<5)|(1<<4)|(1<<3)|(1<<2)|(1<<1)|(0<<0) ; 0xB8	;    =0

		rcall		WRITE_COMMAND1	; ADR

		rcall		One_ms
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms

		ldi			BUF,(0<<7)|(1<<6)|(0<<5)|(0<<4)|(0<<3)|(0<<2)|(0<<1)|(0<<0) ; 0x40	;    =0

		rcall		WRITE_COMMAND1	; LCD_PAGE	

		ldi			ADR,0x40
		clr			Temp
LOOP_C1_6:								;    1 
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms
		lpm			BUF,Z+
		rcall		WRITE_DATA1
		inc			Temp
		cpse		Temp,ADR			;  =    

		rjmp		LOOP_C1_6

		;--------------------------------------------------------------------------------
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms

		ldi			BUF,(1<<7)|(0<<6)|(1<<5)|(1<<4)|(1<<3)|(1<<2)|(1<<1)|(1<<0) ; 0xB8	;    =0

		rcall		WRITE_COMMAND1	; ADR

		rcall		One_ms
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms

		ldi			BUF,(0<<7)|(1<<6)|(0<<5)|(0<<4)|(0<<3)|(0<<2)|(0<<1)|(0<<0) ; 0x40	;    =0

		rcall		WRITE_COMMAND1	; LCD_PAGE	

		ldi			ADR,0x40
		clr			Temp
LOOP_C1_7:								;    1 
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms
		lpm			BUF,Z+
		rcall		WRITE_DATA1
		inc			Temp
		cpse		Temp,ADR			;  =    

		rjmp		LOOP_C1_7

		;--------------------------------------------------------------------------------


;		 


		;--------------------------------------------------------------------------------
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms

		ldi			BUF,(1<<7)|(0<<6)|(1<<5)|(1<<4)|(1<<3)|(0<<2)|(0<<1)|(0<<0) ; 0xB8	;    =0

		rcall		WRITE_COMMAND2	; ADR

		rcall		One_ms
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms

		ldi			BUF,(0<<7)|(1<<6)|(0<<5)|(0<<4)|(0<<3)|(0<<2)|(0<<1)|(0<<0) ; 0x40	;    =0

		rcall		WRITE_COMMAND2	; LCD_PAGE	

		ldi			ADR,0x40
		clr			Temp
LOOP_C2_0:								;    1 
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms
		lpm			BUF,Z+
		rcall		WRITE_DATA2
		inc			Temp
		cpse		Temp,ADR			;  =    

		rjmp		LOOP_C2_0

		;--------------------------------------------------------------------------------
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms

		ldi			BUF,(1<<7)|(0<<6)|(1<<5)|(1<<4)|(1<<3)|(0<<2)|(0<<1)|(1<<0) ; 0xB8	;    =0

		rcall		WRITE_COMMAND2	; ADR

		rcall		One_ms
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms

		ldi			BUF,(0<<7)|(1<<6)|(0<<5)|(0<<4)|(0<<3)|(0<<2)|(0<<1)|(0<<0) ; 0x40	;    =0

		rcall		WRITE_COMMAND2	; LCD_PAGE	

		ldi			ADR,0x40
		clr			Temp
LOOP_C2_1:								;    1 
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms
		lpm			BUF,Z+
		rcall		WRITE_DATA2
		inc			Temp
		cpse		Temp,ADR			;  =    

		rjmp		LOOP_C2_1

		;--------------------------------------------------------------------------------
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms

		ldi			BUF,(1<<7)|(0<<6)|(1<<5)|(1<<4)|(1<<3)|(0<<2)|(1<<1)|(0<<0) ; 0xB8	;    =0

		rcall		WRITE_COMMAND2	; ADR

		rcall		One_ms
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms

		ldi			BUF,(0<<7)|(1<<6)|(0<<5)|(0<<4)|(0<<3)|(0<<2)|(0<<1)|(0<<0) ; 0x40	;    =0

		rcall		WRITE_COMMAND2	; LCD_PAGE	

		ldi			ADR,0x40
		clr			Temp
LOOP_C2_2:								;    1 
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms
		lpm			BUF,Z+
		rcall		WRITE_DATA2
		inc			Temp
		cpse		Temp,ADR			;  =    

		rjmp		LOOP_C2_2

		;--------------------------------------------------------------------------------
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms

		ldi			BUF,(1<<7)|(0<<6)|(1<<5)|(1<<4)|(1<<3)|(0<<2)|(1<<1)|(1<<0) ; 0xB8	;    =0

		rcall		WRITE_COMMAND2	; ADR

		rcall		One_ms
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms

		ldi			BUF,(0<<7)|(1<<6)|(0<<5)|(0<<4)|(0<<3)|(0<<2)|(0<<1)|(0<<0) ; 0x40	;    =0

		rcall		WRITE_COMMAND2	; LCD_PAGE	

		ldi			ADR,0x40
		clr			Temp
LOOP_C2_3:								;    1 
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms
		lpm			BUF,Z+
		rcall		WRITE_DATA2
		inc			Temp
		cpse		Temp,ADR			;  =    

		rjmp		LOOP_C2_3

		;--------------------------------------------------------------------------------
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms

		ldi			BUF,(1<<7)|(0<<6)|(1<<5)|(1<<4)|(1<<3)|(1<<2)|(0<<1)|(0<<0) ; 0xB8	;    =0

		rcall		WRITE_COMMAND2	; ADR

		rcall		One_ms
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms

		ldi			BUF,(0<<7)|(1<<6)|(0<<5)|(0<<4)|(0<<3)|(0<<2)|(0<<1)|(0<<0) ; 0x40	;    =0

		rcall		WRITE_COMMAND2	; LCD_PAGE	

		ldi			ADR,0x40
		clr			Temp
LOOP_C2_4:								;    1 
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms
		lpm			BUF,Z+
		rcall		WRITE_DATA2
		inc			Temp
		cpse		Temp,ADR			;  =    

		rjmp		LOOP_C2_4

		;--------------------------------------------------------------------------------
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms

		ldi			BUF,(1<<7)|(0<<6)|(1<<5)|(1<<4)|(1<<3)|(1<<2)|(0<<1)|(1<<0) ; 0xB8	;    =0

		rcall		WRITE_COMMAND2	; ADR

		rcall		One_ms
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms

		ldi			BUF,(0<<7)|(1<<6)|(0<<5)|(0<<4)|(0<<3)|(0<<2)|(0<<1)|(0<<0) ; 0x40	;    =0

		rcall		WRITE_COMMAND2	; LCD_PAGE	

		ldi			ADR,0x40
		clr			Temp
LOOP_C2_5:								;    1 
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms
		lpm			BUF,Z+
		rcall		WRITE_DATA2
		inc			Temp
		cpse		Temp,ADR			;  =    

		rjmp		LOOP_C2_5

		;--------------------------------------------------------------------------------
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms

		ldi			BUF,(1<<7)|(0<<6)|(1<<5)|(1<<4)|(1<<3)|(1<<2)|(1<<1)|(0<<0) ; 0xB8	;    =0

		rcall		WRITE_COMMAND2	; ADR

		rcall		One_ms
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms

		ldi			BUF,(0<<7)|(1<<6)|(0<<5)|(0<<4)|(0<<3)|(0<<2)|(0<<1)|(0<<0) ; 0x40	;    =0

		rcall		WRITE_COMMAND2	; LCD_PAGE	

		ldi			ADR,0x40
		clr			Temp
LOOP_C2_6:								;    1 
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms
		lpm			BUF,Z+
		rcall		WRITE_DATA2
		inc			Temp
		cpse		Temp,ADR			;  =    

		rjmp		LOOP_C2_6

		;--------------------------------------------------------------------------------
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms

		ldi			BUF,(1<<7)|(0<<6)|(1<<5)|(1<<4)|(1<<3)|(1<<2)|(1<<1)|(1<<0) ; 0xB8	;    =0

		rcall		WRITE_COMMAND2	; ADR

		rcall		One_ms
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms

		ldi			BUF,(0<<7)|(1<<6)|(0<<5)|(0<<4)|(0<<3)|(0<<2)|(0<<1)|(0<<0) ; 0x40	;    =0

		rcall		WRITE_COMMAND2	; LCD_PAGE	

		ldi			ADR,0x40
		clr			Temp
LOOP_C2_7:								;    1 
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms
		rcall		One_ms
		lpm			BUF,Z+
		rcall		WRITE_DATA2
		inc			Temp
		cpse		Temp,ADR			;  =    

		rjmp		LOOP_C2_7

		;--------------------------------------------------------------------------------



		BBB:
		rjmp		BBB

		ldi			Temp,0x08			; 8
		cpse		r1,Temp


;BBB:
;		rjmp		BBB


TABLE:






;                         ****  1 ****

;                           1  //   1
            .DB            0x00,0x3E,0x51,0x49,0x45,0x3E,0x00,0x00
            .DB            0x00,0x00,0x42,0x7F,0x40,0x00,0x00,0x00
            .DB            0x00,0x42,0x61,0x51,0x49,0x46,0x00,0x00
            .DB            0x00,0x21,0x41,0x45,0x4B,0x31,0x00,0x00
            .DB            0x00,0x18,0x14,0x12,0x7F,0x10,0x00,0x00
            .DB            0x00,0x27,0x45,0x45,0x45,0x39,0x00,0x00
            .DB            0x00,0x3C,0x4A,0x49,0x49,0x30,0x00,0x00
            .DB            0x00,0x01,0x71,0x09,0x05,0x03,0x00,0x00
;                           2  //   1
            .DB            0x00,0x36,0x49,0x49,0x49,0x36,0x00,0x00
            .DB            0x00,0x06,0x49,0x49,0x49,0x3E,0x00,0x00
            .DB            0x00,0x00,0x00,0x5F,0x00,0x00,0x00,0x00
            .DB            0x00,0x00,0x07,0x00,0x07,0x00,0x00,0x00
            .DB            0x00,0x14,0x7F,0x14,0x7F,0x14,0x00,0x00
            .DB            0x00,0x24,0x2A,0x7F,0x2A,0x12,0x00,0x00
            .DB            0x00,0x23,0x13,0x08,0x64,0x62,0x00,0x00
            .DB            0x00,0x36,0x49,0x55,0x22,0x50,0x00,0x00
;                           3  //   1
            .DB            0x00,0x00,0x05,0x03,0x00,0x00,0x00,0x00
            .DB            0x00,0x00,0x08,0x08,0x08,0x00,0x00,0x00
            .DB            0x00,0x00,0x30,0x30,0x00,0x00,0x00,0x00
            .DB            0x00,0x20,0x10,0x08,0x04,0x02,0x00,0x00
            .DB            0x00,0x00,0x36,0x36,0x00,0x00,0x00,0x00
            .DB            0x00,0x00,0x56,0x36,0x00,0x00,0x00,0x00
            .DB            0x00,0x08,0x14,0x22,0x41,0x00,0x00,0x00
            .DB            0x00,0x14,0x14,0x14,0x14,0x14,0x00,0x00
;                           4  //   1
            .DB            0x00,0x41,0x22,0x14,0x08,0x00,0x00,0x00
            .DB            0x00,0x02,0x01,0x51,0x09,0x06,0x00,0x00
            .DB            0x00,0x04,0x02,0x01,0x02,0x04,0x00,0x00
            .DB            0x00,0x40,0x40,0x40,0x40,0x40,0x00,0x00
            .DB            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            .DB            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            .DB            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            .DB            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
;                           5  //   1
            .DB            0x00,0x7E,0x11,0x11,0x11,0x7E,0x00,0x00
            .DB            0x00,0x7F,0x49,0x49,0x49,0x36,0x00,0x00
            .DB            0x00,0x3E,0x41,0x41,0x41,0x22,0x00,0x00
            .DB            0x00,0x7F,0x41,0x41,0x22,0x1C,0x00,0x00
            .DB            0x00,0x7F,0x49,0x49,0x49,0x41,0x00,0x00
            .DB            0x00,0x7F,0x09,0x09,0x09,0x01,0x00,0x00
            .DB            0x00,0x3E,0x41,0x41,0x51,0x72,0x00,0x00
            .DB            0x00,0x7F,0x08,0x08,0x08,0x7F,0x00,0x00
;                           6  //   1
            .DB            0x00,0x00,0x41,0x7F,0x41,0x00,0x00,0x00
            .DB            0x00,0x20,0x40,0x41,0x3F,0x01,0x00,0x00
            .DB            0x00,0x7F,0x08,0x14,0x22,0x41,0x00,0x00
            .DB            0x00,0x7F,0x40,0x40,0x40,0x40,0x00,0x00
            .DB            0x00,0x7F,0x02,0x0C,0x02,0x7F,0x00,0x00
            .DB            0x00,0x7F,0x04,0x08,0x10,0x7F,0x00,0x00
            .DB            0x00,0x3E,0x41,0x41,0x41,0x3E,0x00,0x00
            .DB            0x00,0x7F,0x09,0x09,0x09,0x06,0x00,0x00
;                           7  //   1
            .DB            0x00,0x3E,0x41,0x51,0x21,0x5E,0x00,0x00
            .DB            0x00,0x7F,0x09,0x19,0x29,0x46,0x00,0x00
            .DB            0x00,0x46,0x49,0x49,0x49,0x31,0x00,0x00
            .DB            0x00,0x01,0x01,0x7F,0x01,0x01,0x00,0x00
            .DB            0x00,0x3F,0x40,0x40,0x40,0x3F,0x00,0x00
            .DB            0x00,0x1F,0x20,0x40,0x20,0x1F,0x00,0x00
            .DB            0x00,0x3F,0x40,0x30,0x40,0x3F,0x00,0x00
            .DB            0x00,0x63,0x14,0x08,0x14,0x63,0x00,0x00
;                           8  //   1
            .DB            0x00,0x07,0x08,0x70,0x08,0x07,0x00,0x00
            .DB            0x00,0x61,0x51,0x49,0x45,0x43,0x00,0x00
            .DB            0x00,0x20,0x54,0x54,0x54,0x78,0x00,0x00
            .DB            0x00,0x7F,0x48,0x44,0x44,0x38,0x00,0x00
            .DB            0x00,0x38,0x44,0x44,0x44,0x20,0x00,0x00
            .DB            0x00,0x38,0x44,0x44,0x48,0x7F,0x00,0x00
            .DB            0x00,0x38,0x54,0x54,0x54,0x18,0x00,0x00
            .DB            0x00,0x08,0x7E,0x09,0x01,0x02,0x00,0x00

;                          ****  2 ****

;                           1  //   2
            .DB            0x00,0x0C,0x52,0x52,0x52,0x3E,0x00,0x00
            .DB            0x00,0x7F,0x08,0x04,0x04,0x78,0x00,0x00
            .DB            0x00,0x00,0x00,0x44,0x7D,0x40,0x00,0x00
            .DB            0x00,0x20,0x40,0x44,0x3D,0x00,0x00,0x00
            .DB            0x00,0x7F,0x10,0x28,0x44,0x00,0x00,0x00
            .DB            0x00,0x00,0x41,0x7F,0x40,0x00,0x00,0x00
            .DB            0x00,0x7C,0x04,0x18,0x04,0x78,0x00,0x00
            .DB            0x00,0x7C,0x08,0x04,0x04,0x78,0x00,0x00
;                           2  //   2
            .DB            0x00,0x38,0x44,0x44,0x44,0x38,0x00,0x00
            .DB            0x00,0x7C,0x14,0x14,0x14,0x08,0x00,0x00
            .DB            0x00,0x08,0x14,0x14,0x18,0x7C,0x00,0x00
            .DB            0x00,0x7C,0x08,0x04,0x04,0x08,0x00,0x00
            .DB            0x00,0x48,0x54,0x54,0x54,0x20,0x00,0x00
            .DB            0x00,0x04,0x3F,0x44,0x40,0x20,0x00,0x00
            .DB            0x00,0x3C,0x40,0x40,0x20,0x7C,0x00,0x00
            .DB            0x00,0x1C,0x20,0x40,0x20,0x1C,0x00,0x00
;                           3  //   2
            .DB            0x00,0x3C,0x40,0x30,0x40,0x3C,0x00,0x00
            .DB            0x00,0x44,0x28,0x10,0x28,0x44,0x00,0x00
            .DB            0x00,0x0C,0x50,0x50,0x50,0x3C,0x00,0x00
            .DB            0x00,0x44,0x64,0x54,0x4C,0x44,0x00,0x00
            .DB            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            .DB            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            .DB            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            .DB            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
;                           4  //   2
            .DB            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            .DB            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            .DB            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            .DB            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            .DB            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            .DB            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            .DB            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            .DB            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
;                           5  //   2
            .DB            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            .DB            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            .DB            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            .DB            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            .DB            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            .DB            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            .DB            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            .DB            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
;                           6  //   2
            .DB            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            .DB            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            .DB            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            .DB            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            .DB            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            .DB            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            .DB            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            .DB            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
;                           7  //   2
            .DB            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            .DB            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            .DB            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            .DB            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            .DB            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            .DB            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            .DB            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            .DB            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
;                           8  //   2
            .DB            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            .DB            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            .DB            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            .DB            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            .DB            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            .DB            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            .DB            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            .DB            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00










;  Xms, X   W ********************************************************************

X_ms:							;  X ms
LoopX:
		rcall	One_ms			;  1ms
		dec		TimerX			;  X
		brne	LoopX			;   TimerX = 0
		ret						; 
	
;   1ms (1000 ) ********************************************************************

;	10^-3    ms 
;	10^-6    s 

	
One_ms:
		ldi		Timer1,0x02		;  249    = F9
	Looop1:	
		nop						;    4 
		dec		Timer1			;   1 Timer1
		brne	Looop1			;   Timer1 = 0
		nop
		ret						; 

;**************************************************************************************************


	
end:

